local frame = CreateFrame("Frame")

local function AddFilters()

  function iLevelFilter(self, event, message, user, ...)
    for itemLink in message:gmatch("|%x+|Hitem:.-|h.-|h|r") do
      local itemName, _, _, itemLevel, _, _, _, _, _, _, _ = GetItemInfo(itemLink)    
      if (IsEquippableItem(itemLink)) then
         local txt = itemName..": i"..itemLevel
         message = gsub(message, "(|c%x+|Hitem:.-%[)"..itemName.."(%].-|r)", "%1"..txt.."%2", 1)
      end
    end
    return false, message, user, ...;
  end

  ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_EMOTE", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT_LEADER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", iLevelFilter)
  ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", iLevelFilter);
  ChatFrame_AddMessageEventFilter("CHAT_MSG_LOOT", iLevelFilter);
end

frame:SetScript("OnEvent", function(self, event, ...)
  if event == "ADDON_LOADED" then
    AddFilters()
    frame:UnregisterEvent("ADDON_LOADED")
  end
end)
frame:RegisterEvent("ADDON_LOADED")

